######################################################################
# the name of the two models which must be in the file
global nmos pmos
######################################################################
# generate a model file with the requested over-rides
proc write_model_file { fname xl vt0_nch u0_nch vt0_pch u0_pch } {
    global nmos pmos
    set of [open $fname "w"]
    puts $of "* Generated PTM model"
    puts $of "* XL= $xl VT0_NCH= $vt0_nch U0_NCH= $u0_nch VT0_PCH= $vt0_pch U0_PCH= $u0_pch"
    puts $of ".model nmos nmos level=14"
    array set junk [array get nmos]
    set junk(xl) $xl
    set junk(vth0) $vt0_nch
    set junk(u0) $u0_nch
    foreach par [array names junk] {
	puts $of [format "+ %s = %g" $par $junk($par)]
    }
    unset junk
    puts $of ".model pmos pmos level=14"
    array set junk [array get pmos]
    set junk(xl) $xl
    set junk(vth0) $vt0_pch
    set junk(u0) $u0_pch
    foreach par [array names junk] {
	puts $of [format "+ %s = %g" $par $junk($par)]
    }
    close $of
}
######################################################################
# read a model file and fill in the parameter arrays    
proc read_model_file { fname } {
    global nmos pmos
    set if [open $fname "r"]
    set lines [split [read $if nonewline] "\n"]
    close $if

    foreach line $lines {
# ignore empty lines
	if {[llength $line] == 0} {
#D	    puts stdout "empty line"
	    continue
	}
# ignore comment lines
	if {[regexp {^\*} $line]} {
#D	    puts stdout "comment line: $line"
	    continue
	}
# see a .model line?
	if {[regexp {^\.model} $line]} {
	    set model [lindex $line 1]
	    if {$model != "nmos" && $model != "pmos"} {
		error "cannot deal with model $model on $line"
	    }
#D	    puts stdout ".model line: $line -> $model"
	}
# see a continuation line?
	if {[regexp {^\+} $line]} {
# remove the initial plus
	    set line [string range $line 1 end]
# replace the equal signs by spaces
	    regsub -all "=" $line " " newline
#D	    puts stdout "data line: $newline"
	    set i 0
	    foreach item $newline {
		if {($i % 2) == 0} {
		    set parname [string trim $item]
		} else {
		    set parvalue [string trim $item]		    
		    set ${model}($parname) $parvalue
#D		    puts stdout " -- ${model}($parname) = $parvalue"
		}
		incr i
	    }
	}
    }
}
